jQuery(document).ready(function ($) {
    // Function to select or deselect all checkboxes
    function toggleCheckboxes(checked) {
        $('.posttable input[type="checkbox"]').prop('checked', checked);
    }

    // Event listener for 'Select All' button
    $('#select-all').click(function () {
        toggleCheckboxes(true);
    });

    // Event listener for 'Deselect All' button
    $('#deselect-all').click(function () {
        toggleCheckboxes(false);
    });
});


jQuery(document).ready(function ($) {

    $('#select-all-total').on('click', function() {
        $('#select_total').val('1'); // Set hidden input value to 1
        $('#page-excerpt-table').DataTable().ajax.reload(function() {
            $('#page-excerpt-table').DataTable().page.len(-1).draw(); // Show all entries
            
        });
    });

    
    $('#page-excerpt-table').DataTable({
        "processing": true,
        "serverSide": true,

        "ajax": {
            "url": ajaxurl,
            "type": "POST",
            "data": function (d) {
                // Get the value of the input and add it to the AJAX data
                d.filter_value = $('#filter_status').val();
                d.select_total = $('#select_total').val();

                // Include the action parameter
                d.action = "fetch_my_page_data";
            },
            "dataSrc": function (json) {
            // Check the license details in the response
                if (json.license_details.status !== 'active') {
                    // If license is NOT active, limit the data to 25 items
                    return json.data.slice(0, 25);
                } else {
                    // If license is active, return all data
                    return json.data;
                }
            }
        },
        "columnDefs": [
            { "width": "5%", "targets": 0 },
            { "width": "20%", "targets": 1 },
            { "width": "60%", "targets": 2 },
            { "width": "10%", "targets": 3 },
            { "width": "5%", "targets": 4 },
        ],
        "columns": [
            { "data": "checkbox" },
            { "data": "post_title" },
            { "data": "post_excerpt" },
            { "data": "keyword" },
            { "data": "keyword_p" }
            // Add more columns as needed
        ],
        // "lengthMenu": [[10, 25, 50, 200, 500, 1000, -1], [10, 25, 50, 200, 500, 1000, "All"]],
        "lengthMenu": [[10, 25, 50, 200], [10, 25, 50, 200]],
        "initComplete": function (settings, json) {
            // console.log('Data fetched:', json.license_details);
            if ($('#select_total').val() == '1') {
                $('#page-excerpt-table').DataTable().page.len(-1).draw();  // Set page length to 'All'
                $('.posttable input[type="checkbox"]').prop('checked', true);

            }
        }
    });

    $('#post-excerpt-table').DataTable({
        "processing": true,
        "serverSide": true,

        "ajax": {
            "url": ajaxurl,
            "type": "POST",
            "data": function (d) {
                // Get the value of the input and add it to the AJAX data
                d.filter_value = $('#filter_status').val();
                d.select_total = $('#select_total').val();

                // Include the action parameter
                d.action = "fetch_my_post_data";
            },
            "dataSrc": function (json) {
                // Check the license details in the response
                if (json.license_details.status !== 'active') {
                    // If license is NOT active, limit the data to 25 items
                    return json.data.slice(0, 5);
                } else {
                    // If license is active, return all data
                    return json.data;
                }
            }
        },
        "columnDefs": [
            { "width": "5%", "targets": 0 },
            { "width": "20%", "targets": 1 },
            { "width": "60%", "targets": 2 },
            { "width": "10%", "targets": 3 },
            { "width": "5%", "targets": 4 },
        ],
        "columns": [
            { "data": "checkbox" },
            { "data": "post_title" },
            { "data": "post_excerpt" },
            { "data": "keyword" },
            { "data": "keyword_p" }
            // Add more columns as needed
        ],
        // "lengthMenu": [[10, 25, 50, 200, 500, 1000, -1], [10, 25, 50, 200, 500, 1000, "All"]],
        "lengthMenu": [[10, 25, 50, 200], [10, 25, 50, 200]],
        "initComplete": function (settings, json) {
            // console.log('Data fetched:', json);
            if ($('#select_total').val() == '1') {
                $('#page-excerpt-table').DataTable().page.len(-1).draw();  // Set page length to 'All'
                $('.posttable input[type="checkbox"]').prop('checked', true);
            }
        }
    });

    setTimeout(function () {
        if($('#select_total').val() == '1') {
            $('.posttable input[type="checkbox"]').prop('checked', true);
            console.log('Select');
        }
    }, 1200);

    

    // $('#post-excerpt-table').DataTable({
    //     "pageLength": 10,
    //     "lengthMenu": [[10, 25, 50, 200, 500, 1000, -1], [10, 25, 50, 200, 500, 1000, "All"]]
    // });
});


// jQuery(document).ready(function ($) {
//     $('#post-excerpt-form').on('submit', function (e) {
//         e.preventDefault();
//         console.log($('#post-excerpt-form').serialize());
//         // Perform AJAX request
//         $.ajax({
//             type: 'POST',
//             url: ajaxurl,
//             data: $('#post-excerpt-form').serialize(),
//             success: function (response) {
//                 try {
//                     var result = $.parseJSON(response);
//                     if (result.success) {
//                         console.log(result);
//                         alert(result.message);
//                     } else {
//                         console.error(result.message);
//                         alert('Error updating excerpts.');
//                     }
//                 } catch (error) {
//                     alert('Please Select page first');
//                 }
//             }
//         });
//     });
// });

jQuery(document).ready(function ($) {
    $('#update-excerpts').on('click', function () {

        $('#progress-bar').show();
        $('#progress-text').show();
        $('#loaderUpdate').show();
        this.disabled = true;

        // Retrieve selected pages
        var selectedPages = [];
        $('input[name="selected_pages[]"]:checked').each(function () {
            selectedPages.push($(this).val());
        });

        if (selectedPages.length < 1) {
            $('#progress-bar').hide();
            $('#progress-text').hide();
            $('#loaderUpdate').hide();

            this.disabled = false;

            alert('Please Select page first');
            return;
        }

        if ($('input[name="api_key"]').val() == '') {
            $('#progress-bar').hide();
            $('#progress-text').hide();
            $('#loaderUpdate').hide();

            this.disabled = false;

            alert('Please set the API key first');
            return;
        }

        var nonce = $('input[name="page_excerpt_nonce"]').val();

        var chunkedPages = [];
        var chunkSize = 1;
        for (var i = 0; i < selectedPages.length; i += chunkSize) {
            chunkedPages.push(selectedPages.slice(i, i + chunkSize));
        }

        // Set the total number of chunks for the progress bar
        var totalChunks = chunkedPages.length;

        // Set up the progress bar
        var progressBar = $('#progress-bar')[0]; // Get the raw DOM element
        var progressText = $('#progress-text');

        progressBar.max = totalChunks;



        // Function to process each chunk
        function processChunk(index) {
            if (index < chunkedPages.length) {
                var data = {
                    action: 'update_post_excerpts', // AJAX action
                    nonce: nonce,
                    request_for: 'excerpts',
                    selected_pages: chunkedPages[index]
                };

                // Perform AJAX request
                $.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    data: data,
                    success: function (response) {
                        var result = response.data.message;
                        var success = response.success;
                        if(success) {

                            progressBar.value = index + 1;
                            var percentage = ((index + 1) / totalChunks) * 100;
                            progressText.css('width', percentage + '%');

                            if (percentage < 100) {
                                progressText.text(percentage.toFixed(2) + '%');
                            } else {
                                progressText.text(percentage.toFixed(2) + '% Completed. Please Refresh the page.');
                            }

                            // Process the next chunk
                            setTimeout(function () {
                                processChunk(index + 1);
                            }, 3000);

                           
                            if (index === chunkedPages.length - 1) {
                                //  $('#progress-bar').hide();
                                //  $('#progress-text').hide();
                                $('#loaderUpdate').hide();

                            }
                            

                        } else {
                            var result = response.data.message;

                            // console.log(result);

                            var percentage = 100;
                            progressText.css('width', percentage + '%');
                            progressText.css('background-color', 'red');

                            progressText.text(result);

                            $('#loaderUpdate').hide();

                        }

                        
                    },
                    error: function () {
                        console.error('Error in AJAX request');
                        this.disabled = true;

                        $('#progress-bar').hide();
                        $('#progress-text').hide();
                        $('#loaderUpdate').hide();

                    }
                });
            }
        }

        // Start processing chunks
        processChunk(0);
    });



    //For titles

    $('#update-titles').on('click', function () {

        $('#progress-bar').show();
        $('#progress-text').show();
        $('#loaderUpdate').show();
        this.disabled = true;

        // Retrieve selected pages
        var selectedPages = [];
        $('input[name="selected_pages[]"]:checked').each(function () {
            selectedPages.push($(this).val());
        });

        if (selectedPages.length < 1) {
            $('#progress-bar').hide();
            $('#progress-text').hide();
            $('#loaderUpdate').hide();

            this.disabled = false;

            alert('Please Select page first');
            return;
        }

        if ($('input[name="api_key"]').val() == '') {
            $('#progress-bar').hide();
            $('#progress-text').hide();
            $('#loaderUpdate').hide();

            this.disabled = false;

            alert('Please set the API key first');
            return;
        }

        var nonce = $('input[name="page_excerpt_nonce"]').val();

        var chunkedPages = [];
        var chunkSize = 1;
        for (var i = 0; i < selectedPages.length; i += chunkSize) {
            chunkedPages.push(selectedPages.slice(i, i + chunkSize));
        }

        // Set the total number of chunks for the progress bar
        var totalChunks = chunkedPages.length;

        // Set up the progress bar
        var progressBar = $('#progress-bar')[0]; // Get the raw DOM element
        var progressText = $('#progress-text');

        progressBar.max = totalChunks;



        // Function to process each chunk
        function processChunk(index) {
            if (index < chunkedPages.length) {
                var data = {
                    action: 'update_post_titles', // AJAX action
                    nonce: nonce,
                    request_for: 'title',
                    selected_pages: chunkedPages[index]
                };

                // Perform AJAX request
                $.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    data: data,
                    success: function (response) {
                        var result = response.data.message;
                        var success = response.success;
                        if(success) {

                            progressBar.value = index + 1;
                            var percentage = ((index + 1) / totalChunks) * 100;
                            progressText.css('width', percentage + '%');

                            if (percentage < 100) {
                                progressText.text(percentage.toFixed(2) + '%');
                            } else {
                                progressText.text(percentage.toFixed(2) + '% Completed. Please Refresh the page.');
                            }

                            // Process the next chunk
                            setTimeout(function () {
                                processChunk(index + 1);
                            }, 3000);

                            if (index === chunkedPages.length - 1) {
                                //  $('#progress-bar').hide();
                                //  $('#progress-text').hide();
                                $('#loaderUpdate').hide();

                            }

                        } else {
                            var result = response.data.message;

                            // console.log(result);

                            var percentage = 100;
                            progressText.css('width', percentage + '%');
                            progressText.css('background-color', 'red');

                            progressText.text(result);

                              $('#loaderUpdate').hide();

                            

                        }



                    },
                    error: function () {
                        console.error('Error in AJAX request');
                        this.disabled = true;

                        $('#progress-bar').hide();
                        $('#progress-text').hide();
                        $('#loaderUpdate').hide();

                    }
                });
            }
        }

        // Start processing chunks
        processChunk(0);
    });





});






jQuery(document).ready(function ($) {

    $('#keyword_type').change(function () {
        var type = $(this).val();
        if (type === 'post' || type === 'page') {
            var data = {
                action: 'get_total_count', // AJAX action
                type: type
            };
            $.ajax({
                url: ajaxurl,
                type: 'GET',
                data: data,
                success: function (response) {
                    $('#all_posts_input').empty();
                    var ids = JSON.parse(response);
                    $.each(ids, function (index, postId) {
                        var input = $('<input>').attr({
                            type: 'hidden',
                            name: 'selected_pages[]',
                            value: postId
                        });
                        $('#all_posts_input').append(input);
                    });
                    $('#totalPost').text("Total " + type + "s: " + ids.length);
                    $('#total_post_page').val(ids.length);
                    if (ids.length >= 500) {
                        $('#all_keywords').hide();
                    }
                },
                error: function (xhr, status, error) {
                    console.error(error);
                }
            });
        } else {
            $('#totalPost').text('You must select the type First');
            $('#total_post_page').val(0);
            $('#all_posts_input').empty();
        }
    });


    $('#all_keywords').on('input', function () {
        var keywords = $('#total_post_page').val();

        if (keywords > 0) {

            var inputText = $(this).val();
            var lines = inputText.split(/\r\n|\r|\n/);

            lines = lines.filter(function (line) {
                return line.trim() !== '';
            });
            var lineCount = lines.length;
            $('#totalKeyword').text("Total Keywords: " + lineCount + " (Required: " + keywords + ")");


        } else {
            alert('First, you need to select your type');
            $('#all_keywords').val('');
        }
    });



    $('#keywordsSync').on('click', function () {

        var total_need = $('#total_post_page').val();
        var all_keywords = $('#all_keywords').val();
        var keyword_type = $('#keyword_type').val();
        var lines = all_keywords.split(/\r\n|\r|\n/);
        lines = lines.filter(function (line) {
            return line.trim() !== '';
        });
        var total_keywords = lines;

        if (total_need > total_keywords.length) {
            alert('Please input a minimum number of required keywords');
            return;
        }


        $('#progress-bar').show();
        $('#progress-text').show();
        $('#loaderUpdate').show();
        this.disabled = true;

        // Retrieve selected pages
        var selectedPages = [];
        $('input[name="selected_pages[]"]').each(function () {
            selectedPages.push($(this).val());
        });
        // console.log(selectedPages);

        if (selectedPages.length < 1) {
            $('#progress-bar').hide();
            $('#progress-text').hide();
            $('#loaderUpdate').hide();

            this.disabled = false;

            alert('Please Select page first');
            return;
        }

        if ($('input[name="api_key"]').val() == '') {
            $('#progress-bar').hide();
            $('#progress-text').hide();
            $('#loaderUpdate').hide();

            this.disabled = false;

            alert('Please set the API key first');
            return;
        }

        var nonce = $('input[name="page_excerpt_nonce"]').val();

        var chunkedPages = [];
        var chunkSize = 1;
        for (var i = 0; i < selectedPages.length; i += chunkSize) {
            chunkedPages.push(selectedPages.slice(i, i + chunkSize));
        }

        // Set the total number of chunks for the progress bar
        var totalChunks = chunkedPages.length;

        // Set up the progress bar
        var progressBar = $('#progress-bar')[0]; // Get the raw DOM element
        var progressText = $('#progress-text');

        progressBar.max = totalChunks;



        // Function to process each chunk
        function processChunk(index) {
            if (index < chunkedPages.length) {
                var data = {
                    action: 'sync_keywords',
                    nonce: $('input[name="page_excerpt_nonce"]').val(),
                    selected_pages: chunkedPages[index],
                    total_keywords: total_keywords,
                    keyword_type: keyword_type,
                };

                // console.log(total_keywords);
                // Perform AJAX request
                $.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    data: data,
                    success: function (response) {
                        try {
                            var result = $.parseJSON(response);
                            if (result.success) {
                                // console.log(result.keyword);
                                var keywordToRemove = result.keyword; // Convert keyword to remove to lowercase

                                // // Find the index of the keyword to remove, ignoring case
                                let kindex = total_keywords.map(keyword => keyword.trim().toLowerCase())
                                    .findIndex(keyword => keyword === keywordToRemove.toLowerCase());

                                // console.log(keywordToRemove);
                                console.log(kindex);
                                if (kindex !== -1) {
                                    total_keywords.splice(kindex, 1);

                                }
                            } else {
                                // console.error(result.message);
                            }
                        } catch (error) {
                            console.error('Error parsing response');
                        }

                        progressBar.value = index + 1;
                        var percentage = ((index + 1) / totalChunks) * 100;
                        progressText.css('width', percentage + '%');

                        if (percentage < 100) {
                            progressText.text(percentage.toFixed(2) + '%');
                        } else {
                            progressText.text(percentage.toFixed(2) + '% Completed. Please Refresh the page.');
                        }

                        // Process the next chunk
                        setTimeout(function () {
                            processChunk(index + 1);
                        }, 3000);

                        if (index === chunkedPages.length - 1) {
                            //  $('#progress-bar').hide();
                            //  $('#progress-text').hide();
                            $('#loaderUpdate').hide();

                        }
                    },
                    error: function () {
                        // console.error('Error in AJAX request');
                        this.disabled = true;

                        $('#progress-bar').hide();
                        $('#progress-text').hide();
                        $('#loaderUpdate').hide();

                    }
                });
            }
        }

        // Start processing chunks
        processChunk(0);
    });



});


jQuery(document).ready(function($) {
    $('#check_license_button').click(function() {
        var licenseKey = $('#post_excerpt_license_key').val(); 
        var licenseEmail = $('#post_excerpt_license_email').val(); 
        $('#license_check_result').html('Checking...'); 
        // console.log(licenseEmail);

        // AJAX request
        $.ajax({
            url: ajaxurl, // This is the default WordPress AJAX URL
            type: 'POST',
            data: {
                action: 'check_license_key', // The action hook we'll define in PHP
                license_key: licenseKey,
                license_email: licenseEmail
            },
            success: function(response) {
                if (response.success) {
                    $('#license_check_result').html('<span style="color: green;">' + response.data + '</span>');
                    setTimeout(function() {
                        location.reload(); // This will reload the page
                    }, 500);
                } else {
                    $('#license_check_result').html('<span style="color: red;">' + response.data + '</span>'); // Display error message
                }
            },
            error: function() {
                $('#license_check_result').html('<span style="color: red;">Error checking the license key. Please try again.</span>'); // Display generic error message
            }
        });
    });
});