<?php

function keywords_settings_page_this_plugin()
{

    // if (isset($_POST['post_excerpt_keyword_submit'])) {

    //     if (isset($_POST['keyword_type'])) {
    //         $api_key = sanitize_text_field($_POST['keyword_type']);
    //         update_option('keyword_type', $api_key);
    //     }
    //     if (isset($_POST['extra_instructions'])) {
    //         $api_key = sanitize_text_field($_POST['extra_instructions']);
    //         update_option('extra_instructions', $api_key);
    //     }
    //     if (isset($_POST['post_excerpt_api_model'])) {
    //         $post_excerpt_api_model = sanitize_text_field($_POST['post_excerpt_api_model']);
    //         update_option('post_excerpt_api_model', $post_excerpt_api_model);
    //     }
    //     if (isset($_POST['extra_instructions_for_title'])) {
    //         $extra_instructions_for_title = sanitize_text_field($_POST['extra_instructions_for_title']);
    //         update_option('extra_instructions_for_title', $extra_instructions_for_title);
    //     }
    // }


    // Retrieve the saved API key
    $keyword_type = get_option('keyword_type');
    $extra_instructions = get_option('extra_instructions');
    $extra_instructions_for_title = get_option('extra_instructions_for_title');
    $api_model = get_option('post_excerpt_api_model');

    $api_key = get_option('post_excerpt_api_key');


    // Display the settings page HTML
?>
    <div class="wrap">
        <h2> Keywords Settings</h2>
        <form method="post" action="">

            <input type="hidden" name="page_excerpt_nonce" value="<?php echo wp_create_nonce('update_post_excerpts_nonce'); ?>">
            <input type="hidden" name="api_key" value="<?php echo $api_key  ?>">

            <table class="form-table">
                <tbody>


                    <tr>
                        <th scope="row">Select Type</th>
                        <td>
                            <select style="width: 500px;" id="keyword_type" name="keyword_type" require>
                                <option value="">Select Post/Page First</option>
                                <option value="post" <?php selected($keyword_type, 'post'); ?>>Post</option>
                                <option value="page" <?php selected($keyword_type, 'page'); ?>>Page</option>
                            </select><br>
                            <span id="totalPost" style="color: red">You must select the type First</span>
                            <input type="hidden" name="total_post_page" id="total_post_page" value="0">
                        </td>
                    </tr>


                    <tr>
                        <th scope="row">Enter All keywords (With New Line) </th>
                        <td>
                            <textarea name="all_keywords" id="all_keywords" style="width: 500px;" rows="20" cols="40"></textarea>
                            <br>
                            <span id="totalKeyword"></span>

                        </td>

                    </tr>

                </tbody>
            </table>

            <div id="all_posts_input">

            </div>

            <!-- 
            <label for="post_excerpt_api_key">API Key:</label>
            <input type="text" style="width: 500px;" id="post_excerpt_api_key" name="post_excerpt_api_key" value="<?php echo esc_attr($api_key); ?>">
            <p>Enter your API key here.</p> -->
            <div style="padding-top: 20px;">
                <input type="button" name="post_excerpt_keyword_submit" id="keywordsSync" class="button-primary" value="Sync Keywords">
                <img style="display: none;" id="loaderUpdate" src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/images/loading.gif" alt="Loading...">

                <div id="progress-bar">
                    <div id="progress-text">0%</div>
                </div>
            </div>
    </div>
    </form>

<?php
}


function get_total_count()
{
    $type = isset($_GET['type']) ? $_GET['type'] : '';
    $ids = [];

    if ($type === 'post' || $type === 'page') {
        $query_args = [
            'post_type' => $type,
            'post_status' => 'publish',
            'orderby' => 'ID',  // Order by post ID
            'order' => 'ASC',   // Ascending order
            'fields' => 'ids', // Only get post IDs
            'posts_per_page' => -1, // Get all posts
        ];
        $query = new WP_Query($query_args);
        $ids = $query->posts;
    }

    echo json_encode($ids); // Return the IDs as a JSON string
    wp_die();
}


// Hook the AJAX handler function
add_action('wp_ajax_get_total_count', 'get_total_count');
add_action('wp_ajax_nopriv_get_total_count', 'get_total_count');


add_action('wp_ajax_sync_keywords', 'sync_keywords');
add_action('wp_ajax_nopriv_sync_keywords', 'sync_keywords');


function sync_keywords()
{

    if (check_ajax_referer('update_post_excerpts_nonce', 'nonce', false)) {
        if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['selected_pages'])) {
            // Retrieve the API key
            $api_key = get_option('post_excerpt_api_key');
            $extra_instructions = get_option('extra_instructions');

            // Check if API Key is available
            if (empty($api_key)) {
                echo json_encode(array('error' => true, 'message' => 'OpenAI API key is missing.'));
                wp_die();
            }
            // echo json_encode(array('success' => true, 'message' => $api_key));

            // Process the selected pages and extra instructions
            if (!empty($_POST['selected_pages']) && !empty($_POST['total_keywords'])) {
                $selected_pages = $_POST['selected_pages'];
                $keyword_type = $_POST['keyword_type'];
                $total_keywords = $_POST['total_keywords'];

                $total_keywordsdata = implode(", ", $total_keywords);

                // foreach ($selected_pages as $page_id) {
                $page_id = $selected_pages[0];
                $page = get_post($page_id);

                if (!$page) {
                    echo json_encode(array('error' => true, 'message' => 'Page/Post not found.'));
                }

                $page_link = get_permalink($page_id);

                $select_keyword_one = select_keywords_one($page->post_title, $api_key, $total_keywordsdata, $page->post_excerpt);

                $keywod_matching_percent = keywod_matching_percent($page->post_title, $api_key, $total_keywordsdata, $page->post_excerpt, $select_keyword_one);

                $keywodOutput = explode('-', $select_keyword_one);
                $the_keyword = trim($keywodOutput[1]);
                $final_keyword = str_replace(".", "", $the_keyword);

                
                

                // Assuming $page_id is defined and holds the ID of the post you're updating
                wp_set_post_tags($page_id, $final_keyword, true);

                // Update or add the 'rank_math_focus_keyword' metadata
                update_post_meta($page_id, 'rank_math_focus_keyword', $final_keyword);

                // Update or add the 'keyword_matching_percent' metadata
                update_post_meta($page_id, 'keyword_matching', $final_keyword);
                update_post_meta($page_id, 'keyword_matching_percent', $keywod_matching_percent);


                echo json_encode(array('success' => true, 'keyword' => $final_keyword, 'percent' => $keywod_matching_percent, 'message' => 'Excerpts updated successfully.'));
            }
            // echo json_encode(array('success' => true, 'message' => 'Excerpts updated successfully.'));
            // }
        }

        wp_die();
    } else {
        echo json_encode(array('error' => true, 'message' => 'Nonce verification failed.'));
    }
}


function select_keywords_one($title, $api_key, $total_keywords, $post_excerpt)
{

    $content = "Using the Post Title: '{$title}' and Post Excerpt: '{$post_excerpt}'. Choose the best matching keyword from this keyword list: '{$total_keywords}'. Output the only the best match  without repeating and Must Be Only the keyword name exact the same as the kewords list with this format : Your keyword is - keywor_name ";

    $api_model = get_option('post_excerpt_api_model') != null ? get_option('post_excerpt_api_model') : 'gpt-3.5-turbo';

    $data = [
        'model' => $api_model, // or any other model
        'messages' => [['role' => 'user', 'content' => $content]],
        'temperature' => 0.7
    ];


    // return $content;

    $args = array(
        'body'    => json_encode($data),
        'headers' => array(
            'Content-Type'  => 'application/json',
            'Authorization' => 'Bearer ' . $api_key
        )
    );

    $response = wp_remote_post('https://api.openai.com/v1/chat/completions', $args);

    // return $response;

    if (is_wp_error($response)) {
        // Handle error more specifically if needed
        return null;
    }

    // return $response;
    $body = wp_remote_retrieve_body($response);
    $result = json_decode($body, true);
    // return $result;
    // Check for valid response
    if (!isset($result['choices'][0]['message']['content'])) {
        return null;
    }

    return $result['choices'][0]['message']['content'];
}



function keywod_matching_percent($title, $api_key, $total_keywords, $post_excerpt, $select_keyword_one)
{

    $content = "give me a 1% - 100% on how well '{$select_keyword_one}' matches the page: '{$title}' and description:'{$post_excerpt}', only output must be the number with % and nothing else";

    $api_model = get_option('post_excerpt_api_model') != null ? get_option('post_excerpt_api_model') : 'gpt-3.5-turbo';

    $data = [
        'model' => $api_model, // or any other model
        'messages' => [['role' => 'user', 'content' => $content]],
        'temperature' => 0.7
    ];


    

    $args = array(
        'body'    => json_encode($data),
        'headers' => array(
            'Content-Type'  => 'application/json',
            'Authorization' => 'Bearer ' . $api_key
        )
    );

    $response = wp_remote_post('https://api.openai.com/v1/chat/completions', $args);

    // return $response;

    if (is_wp_error($response)) {
        // Handle error more specifically if needed
        return null;
    }

    // return $response;
    $body = wp_remote_retrieve_body($response);
    $result = json_decode($body, true);
    // return $result;
    // Check for valid response
    if (!isset($result['choices'][0]['message']['content'])) {
        return null;
    }

    return $result['choices'][0]['message']['content'];
}
