<?php


function page_excerpt_settings_page_this_plugin()
{


    // Include the separated code file
    // include_once(plugin_dir_path(__FILE__) . 'data-submit.php');

    $api_key = get_option('post_excerpt_api_key');
    $args = array(
        'post_type'      => 'page',
        'posts_per_page' => -1,
        'post_status'    => 'publish',
    );



    $pages = get_posts($args);

    usort($pages, 'compare_excerpt_length');

?>


    <div class="wrap" style="padding: 50px;  background-color: white;">
        <h1  style="text-align: center;">Update Post Excerpts</h1>
        <form method="post" id="post-excerpt-form">

            <input type="hidden" name="action" value="update_post_excerpts">

            <input type="hidden" name="api_key" value="<?php echo $api_key  ?>">


            <input type="hidden" name="page_excerpt_nonce" value="<?php echo wp_create_nonce('update_post_excerpts_nonce'); ?>">

            <table class="posttable form-table" id="post-excerpt-table">
                <thead>
                    <tr>
                        <th>CheckBox</th>
                        <th>Title</th>
                        <th>Post Excerpt</th>
                        <th>Keyword</th>
                        <th>Match</th>
                    </tr>
                </thead>
                <tbody>

                    <?php foreach ($pages as $page) : ?>
                        <?php if (isset($_POST['filter_posts']) && empty($page->post_excerpt)) : ?>
                            <!-- Display only posts with empty excerpt when Filter Posts is clicked -->
                            <tr>
                                <td width="2%"><input type="checkbox" name="selected_pages[]" value="<?php echo esc_attr($page->ID); ?>"></td>
                                <td width="20%"><?php echo esc_html($page->post_title); ?></td>
                                <td width="65%"><?php echo esc_html($page->post_excerpt);?> </td>
                                <td width="10%"><?php echo get_post_meta($page->ID, 'keyword_matching', true)?> </td>
                                <td width="3%"><?php echo get_post_meta($page->ID, 'keyword_matching_percent', true);?> </td>
                            </tr>
                        <?php elseif (!isset($_POST['filter_posts'])) : ?>
                            <tr>
                                <td width="2%"><input type="checkbox" name="selected_pages[]" value="<?php echo esc_attr($page->ID); ?>"></td>
                                <td width="20%"><?php echo esc_html($page->post_title); ?></td>
                                <td width="65%"><?php echo esc_html($page->post_excerpt);
                                                if ($page->post_excerpt != '') {
                                                    echo "<b> (" . strlen($page->post_excerpt) . ")</b>";
                                                }
                                                ?> </td>
                                <td width="10%"><?php echo get_post_meta($page->ID, 'keyword_matching', true)?> </td>
                                <td width="3%"><?php echo get_post_meta($page->ID, 'keyword_matching_percent', true);?> </td>
                            </tr>
                        <?php endif; ?>
                    <?php endforeach; ?>


                     <!-- FOr Post -->

                    <?php foreach ($pages as $page) : ?>
                        <?php if (isset($_POST['filter_posts']) && empty($page->post_excerpt)) : ?>
                            <!-- Display only posts with empty excerpt when Filter Posts is clicked -->
                            <tr>
                                <td width="2%"><input type="checkbox" name="selected_pages[]" value="<?php echo esc_attr($page->ID); ?>"></td>
                                <td width="20%"><?php echo esc_html($page->post_title); ?></td>
                                <td width="65%"><?php echo esc_html($page->post_excerpt);

                                                ?> </td>
                                <td width="10%"><?php echo get_post_meta($page->ID, 'keyword_matching', true) ?> </td>
                                <td width="3%"><?php echo get_post_meta($page->ID, 'keyword_matching_percent', true); ?> </td>

                            </tr>
                        <?php elseif (!isset($_POST['filter_posts'])) : ?>
                            <!-- Display all other posts -->
                            <tr>
                                <td width="2%"><input type="checkbox" name="selected_pages[]" value="<?php echo esc_attr($page->ID); ?>"></td>
                                <td width="20%"><?php echo esc_html($page->post_title); ?></td>
                                <td width="65%"><?php echo esc_html($page->post_excerpt);
                                                if ($page->post_excerpt != '') {
                                                    echo "<b> (" . strlen($page->post_excerpt) . ")</b>";
                                                }
                                                ?> </td>
                                <td width="10%"><?php echo get_post_meta($page->ID, 'keyword_matching', true) ?> </td>
                                <td width="3%"><?php echo get_post_meta($page->ID, 'keyword_matching_percent', true); ?> </td>

                            </tr>
                        <?php endif; ?>
                    <?php endforeach; ?>


                </tbody>
            </table>

            <div style="padding-top: 20px;">
                <button type="button" id="select-all">Select All</button>
                <button type="button" style="margin-right: 20px;" id="deselect-all">Deselect All</button>
                <?php if (!isset($_POST['filter_posts'])) : ?>
                    <button type="submit" name="filter_posts">Filter Without Excerpt Pages</button> <!-- Add the filter button -->
                <?php else : ?>
                    <button type="submit">Filter All Pages</button> <!-- Add the filter button -->
                <?php endif; ?>
            </div>




            <!-- <table class="form-table">
                <tbody>


                    <tr>
                        <th scope="row">Extra Instructions</th>
                        <td><textarea name="extra_instructions" style="width: 500px;" rows="5" cols="40"></textarea></td>
                    </tr>
                </tbody>
            </table> -->



            <div style="padding-top: 20px;">
                <button type="button" id="update-excerpts" class="button button-primary">Update Excerpts</button>
                <button type="button" id="update-titles" class="button " style="background-color: green; color: white">Update Titles</button>
                <img style="display: none;" id="loaderUpdate" src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/images/loading.gif" alt="Loading...">

                <div id="progress-bar">
                    <div id="progress-text">0%</div>
                </div>
            </div>

            <?php
            //  submit_button('Update Excerpts');
            ?>
        </form>
    </div>


<?php
}
