<?php




function fetch_my_post_data()
{

    $start = isset($_POST['start']) ? intval($_POST['start']) : 0;
    $length = isset($_POST['length']) ? intval($_POST['length']) : 10; // Default to 10 items per page
    $filter_value = isset($_POST['filter_value']) ? $_POST['filter_value'] : '';
    $select_total = isset($_POST['select_total']) ? $_POST['select_total'] : '';

    // print_r($select_total);
    if ($select_total === '1') {
        $length = -1;
    }

   

   

    $args = array(
        'post_type'      => 'post',
        'posts_per_page' => -1, // Temporarily get all posts to filter manually
        'post_status'    => 'publish',
    );

    $all_pages = get_posts($args);

    usort($all_pages, 'compare_excerpt_length');

    if ($filter_value === '1') {
        // Filter out pages with non-empty excerpts
        $all_pages = array_filter($all_pages, function ($page) {
            return empty($page->post_excerpt);
        });
    }

    // Manually apply pagination
    $pages = array_slice($all_pages, $start, $length);
    $total_pages = count($all_pages); // Total pages after filtering

    usort($pages, 'compare_excerpt_length');

    $data = array();
    foreach ($pages as $page) {
        $checkboxColum = '<input type="checkbox" name="selected_pages[]" value="' . esc_attr($page->ID) . '">';
        $keyword = get_post_meta($page->ID, 'keyword_matching', true);
        $keyword_p = get_post_meta($page->ID, 'keyword_matching_percent', true);

        $post_excerpt = $page->post_excerpt;
        $excerpt_length = strlen($post_excerpt);
        if ($excerpt_length > 0) {
            $excerpt_with_counter = $post_excerpt . ' <span><b> (' . $excerpt_length . ')</b></span>';
        } else {
            $excerpt_with_counter = '';
        }

        $data[] = array(
            'checkbox'     => $checkboxColum,
            'post_title'   => $page->post_title,
            'post_excerpt' => $excerpt_with_counter,
            'keyword'      => $keyword,
            'keyword_p'    => $keyword_p,
        );

        // $data[] = array(
        //         'checkbox'     => $checkboxColum,
        //         'post_title'   => $page->post_title,
        //         'post_excerpt' => $page->post_excerpt,
        //         'keyword'      => $keyword,
        //         'keyword_p'    => $keyword_p,
        // );
    }

    $license_details = get_user_meta(get_current_user_id(), 'user_license_details', true);

    wp_send_json(array(
        'draw'            => isset($_POST['draw']) ? intval($_POST['draw']) : 0,
        'recordsTotal'    => $total_pages,
        'recordsFiltered' => $total_pages, // Modify this if implementing search/filter
        'license_details' => !empty($license_details) ? $license_details : '',
        'data'            => $data
    ));
}
add_action('wp_ajax_fetch_my_post_data', 'fetch_my_post_data');


function compare_excerpt_length($a, $b)
{
    $lengthA = strlen(get_the_excerpt($a->ID));
    $lengthB = strlen(get_the_excerpt($b->ID));
    return $lengthA - $lengthB;
}

function post_excerpt_settings_page_this_plugin()
{

    // Include the separated code file
    // include_once(plugin_dir_path(__FILE__) . 'data-submit.php');

    $api_key = get_option('post_excerpt_api_key');
    $args = array(
        'post_type'      => 'post',
        'posts_per_page' => -1,
        'post_status'    => 'publish',
    );



    $pages = get_posts($args);

    usort($pages, 'compare_excerpt_length');

    $license_details = get_user_meta(get_current_user_id(), 'user_license_details', true);

    $license_status = isset($license_details['status']) ? $license_details['status'] : '';




?>


    <div class="wrap" style="padding: 50px;  background-color: white;">

        <h1 style="text-align: center;">Update Post Excerpts</h1>
        <form method="post" id="post-excerpt-form">

            <input type="hidden" name="action" value="update_post_excerpts">
            <input type="hidden" name="api_key" value="<?php echo $api_key  ?>">

            <input type="hidden" name="page_excerpt_nonce" value="<?php echo wp_create_nonce('update_post_excerpts_nonce'); ?>">


            <table class="posttable form-table" id="post-excerpt-table">
                <thead>
                    <tr>
                        <th>CheckBox</th>
                        <th>Title</th>
                        <th>Post Excerpt</th>
                        <th>Keyword</th>
                        <th>Match</th>
                    </tr>
                </thead>
                <tbody>



                </tbody>
            </table>



            <div style="padding-top: 20px;">
                <button type="button" id="select-all">Select All</button>
                <button type="button" style="margin-right: 20px;" id="deselect-all">Deselect All</button>
                <button type="submit" name="select_total_submit">Select All <?php echo wp_count_posts('post')->publish; ?> Posts </button>

                <?php if (!isset($_POST['filter_posts'])) : ?>
                    <button type="submit" name="filter_posts">Filter Without Excerpt Posts</button> <!-- Add the filter button -->
                <?php else : ?>
                    <button type="submit">Filter All Posts</button> <!-- Add the filter button -->
                <?php endif; ?>
                <input type="hidden" name="filter_status" id="filter_status" value="<?php echo !isset($_POST['filter_posts']) ? "0" : "1" ?>" />
                <input type="hidden" name="select_total" id="select_total" value="<?php echo !isset($_POST['select_total_submit']) ? "0" : "1" ?>" />

                <?php if ($license_status !== 'active') : ?>
                    <span style="margin-left: 20px; color: red; font-weight: bold;">
                        You can update up to 25 items without an active license.
                        <a href="<?php echo admin_url('admin.php?page=my-plugin-post-excerpt-api-settings'); ?>" style="color: blue; text-decoration: underline;">
                            Click here to activate your license
                        </a> and unlock full access.
                    </span>
                <?php endif; ?>




            </div>


            <div style="padding-top: 20px;">
                <button type="button" id="update-excerpts" class="button button-primary">Update Excerpts</button>
                <button type="button" id="update-titles" class="button " style="background-color: green; color: white">Update Titles</button>

                </button>
                <img style="display: none;" id="loaderUpdate" src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/images/loading.gif" alt="Loading...">
                <div id="progress-bar">
                    <div id="progress-text">0%</div>
                </div>
            </div>

            <?php
            // submit_button('Update Excerpts'); 
            ?>
        </form>
    </div>


<?php
}
